# Reference
<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

**Classes**

_Public Classes_

* [`root`](#root): Manage root user

_Private Classes_

* `root::kerberos`: Private class
* `root::params`: Private class
* `root::rsakey::export`: Private class

**Defined types**

_Public Defined types_

* [`root::ssh_authorized_key`](#rootssh_authorized_key): Define root user's ssh_authorized_key resources

_Private Defined types_

* `root::rsakey::collect`: Private class

## Classes

### root

Manage root user

#### Examples

##### 

```puppet
include ::root
```

#### Parameters

The following parameters are available in the `root` class.

##### `mailaliases`

Data type: `Array`

An array that defines mailaliases for the root user (defaults to an empty array).
When an empty array is given Mailaliases[root] is set to `ensure => absent`.

Default value: []

##### `mailaliases_hiera_merge`

Data type: `Boolean`

Boolean that determines if the Hiera lookup merging is used for `root::mailaliases` values.

Default value: `true`

##### `ssh_authorized_keys`

Data type: `Variant[Array, Hash]`

Defines ssh_autorized_keys to be passed to the `root::ssh_authorized_key` defined type.
See `root::ssh_authorized_key` for examples of valid formats

Default value: {}

##### `ssh_authorized_keys_hiera_merge`

Data type: `Boolean`

Boolean that determines if the Hiera lookup merging `root::ssh_authorized_keys` values.

Default value: `true`

##### `password`

Data type: `Optional[String]`

The password hash used for the root account.

Default value: `undef`

##### `purge_ssh_keys`

Data type: `Boolean`

Sets if unmanaged SSH keys will be purged for the root account.

Default value: `true`

##### `export_key`

Data type: `Boolean`

Sets if the root SSH RSA key should be created and exported.

Default value: `false`

##### `export_key_options`

Data type: `Optional[Array]`

Options to set for the exported SSH RSA key

Default value: `undef`

##### `export_key_tag`

Data type: `String`

The tag to use when exporting the root SSH RSA key.

Default value: $::domain

##### `collect_exported_keys`

Data type: `Boolean`

Sets if the export root SSH RSA keys should be collected.

Default value: `false`

##### `collect_exported_keys_tags`

Data type: `Array`

Array of tags for root SSH RSA keys to collect.

Default value: [$::domain]

##### `ssh_private_key_source`

Data type: `Optional[String]`

The source for root's SSH RSA private key

Default value: `undef`

##### `ssh_public_key_source`

Data type: `Optional[String]`

The source for root's SSH RSA public key

Default value: `undef`

##### `logout_timeout`

Data type: `Optional[Integer[0, default]]`

Time (in seconds) before idle interactive terminals will logout

Default value: `undef`

##### `manage_kerberos`

Data type: `Boolean`

Boolean that sets if Kerberos files should be managed

Default value: `true`

##### `kerberos_login_principals_hiera_merge`

Data type: `Boolean`

Boolean that determines if the Hiera lookup merging `root::kerberos_login_principals` values.

Default value: `true`

##### `kerberos_login_principals`

Data type: `Array`

The Kerberos principals to write to /root/.k5login

Default value: []

##### `kerberos_users_commands_hiera_merge`

Data type: `Boolean`

Boolean that determines if the Hiera lookup merging `root::kerberos_users_commands` values.

Default value: `true`

##### `kerberos_users_commands`

Data type: `Hash[String[1], Variant[String, Array]]`

The Kerberos user principals and commands to write to /root/.k5users

Default value: {}

## Defined types

### root::ssh_authorized_key

Define root user's ssh_authorized_key resources

#### Examples

##### Define ssh_authorized_key using Hash

```puppet
root::ssh_authorized_key { 'user@fqdn':
  type => 'ssh-rsa',
  key  => 'somelonghash==',
}
```

##### Define ssh_authorized_key using name string

```puppet
root::ssh_authorized_key { 'ssh-rsa somelonghash== user@fqdn': }
```

#### Parameters

The following parameters are available in the `root::ssh_authorized_key` defined type.

##### `ensure`

Data type: `Any`

ssh_authorized_key ensure property

Default value: 'present'

##### `key`

Data type: `Any`

The SSH key hash

Default value: 'UNSET'

##### `options`

Data type: `Any`

The SSH key options

Default value: 'UNSET'

##### `type`

Data type: `Any`

The type of SSH key.

Default value: 'UNSET'

